using System;
using System.Collections.Generic;
using System.Linq;
using System.Collections;
using System.Web;
using System.IO;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Text;
using System.Configuration;
using MySql.Data.MySqlClient;
using Newtonsoft.Json;
using MySql.Data;
using System.Reflection;
using System.Web.Services;
using System.Web.Script.Serialization;
using CLS_BL;
using CLS_DL;
using CLS_PL;

namespace SUNWEB
{
    public partial class OneTimePromocode : System.Web.UI.Page
    {
        BL_SELECT ObjSel = new BL_SELECT();
        BLCompany ObjBL = new BLCompany();
        PLCOMMON ObjPL = new PLCOMMON();
        BL_USER ObjUserBL = new BL_USER(); //This Object for All User and Page Related fuctions included 
        PLCUSTOMER ObjCustPL = new PLCUSTOMER();
        Int32 K = 0;
        Int32 L = 0;
        Int32 S = 0;
        string ConStr = ConfigurationManager.ConnectionStrings["ConMysql"].ConnectionString;
        string ConStr_Rds = ConfigurationManager.ConnectionStrings["ConRDS"].ConnectionString;
        string Curr_Date = System.DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
        string Curr_DateOnly = System.DateTime.Now.ToString("yyyy-MM-dd");
        DateTime MonthstartDt;
        DataSet ds = new DataSet();
        MYSQLDB ObjMain = new MYSQLDB();
        DataTable DT = new DataTable();
        DataTable Dt2 = new DataTable();
        DataTable DtLicense = new DataTable();
        DataTable DtSuperAdmin = new DataTable();
        DataTable DtMultiBranch = new DataTable();
        DataTable DtNormalUser = new DataTable();
        DataTable DTProductSale = new DataTable();
        MySqlCommand Cmdv = new MySqlCommand();
        // User Variables 
        string UserId = string.Empty;
        string UserName = string.Empty;
        string PortalTypeId = string.Empty;
        string cd_Id = string.Empty;
        string Datapath = string.Empty;
        string cd_BranchAlias = string.Empty;
        string IsMultiBranch = string.Empty;
        string IsSuperAdmin = string.Empty;
        string ActiveCallvalue = string.Empty;
        // License Variables ..
        string PID = string.Empty;
        string Page_Acess = string.Empty;
        string Read_Acess = string.Empty;
        string Write_Acess = string.Empty;
        string Isdowld_Acess = string.Empty;
        string Rcd_id = string.Empty;
        string RPortalid = string.Empty;
        string Useridvalue = string.Empty;
        string QueryCurr_Select = string.Empty;
        string L_MaxUserCnt = string.Empty;

        string L_OneTimePromocode = string.Empty;
        string Branchidval = string.Empty;
        string BranchFullName = string.Empty;
        string Curr_BranchFullName = string.Empty;
        string Cmb_BranchName = string.Empty;

        string HQ = string.Empty;
        string Cm_id = string.Empty;
        string ISHQ = string.Empty;
        DataSet DS = new DataSet();
        string BranchAlias = string.Empty;

        string Vw_Chk = string.Empty;

        protected void Page_Load(object sender, EventArgs e)
        {
            btnUpdate.Visible = false;

            PID = "58";    // This is for OnetimePromocode Page.
            if (!IsPostBack)
            {
                txtPromoStartDt.Text = Curr_DateOnly;
                txtPromoEnddt.Text = Curr_DateOnly;
                lblperSynmbol.Visible = false;
            }
            MonthstartDt = new DateTime(System.DateTime.Now.Year, System.DateTime.Now.Month, 1);
            if (Session["UserName"] == null)
            {
                Response.Redirect("Login.aspx");
            }
            if (((Convert.ToBoolean(Session["IsSuperAdmin"])) == true) && (Session["PortalTypeId"].ToString() == "") && ((Convert.ToBoolean(Session["IsMultiBranch"])) == true))
            {
                if (!IsPostBack)
                {
                    LoadBranchName4SuperAdmin();

                    string QueryCal = "select ActiveValue from portaldb.usermaster  where Userid=" + Session["UserId"].ToString() + " ";
                    ActiveCallvalue = ObjMain.ExecuteScalar(QueryCal);
                    if (ActiveCallvalue != " " || ActiveCallvalue != "Select Branch")
                    {
                        ActiveCall();
                    }
                }
            }
            else if (((Convert.ToBoolean(Session["IsSuperAdmin"])) == true) && (Session["PortalTypeId"].ToString() == ""))
            {
                if (!IsPostBack)
                {
                    LoadBranchName4SuperAdmin();
                }
                cd_BranchAlias = cmbBranches.SelectedItem.Text;
                //LoadInventoryListGrid(cd_BranchAlias, txtStartDt.Text, txtEndDt.Text);
            }
            else if (((Convert.ToBoolean(Session["IsMultiBranch"])) == true) && (Session["PortalTypeId"].ToString() == ""))
            {
                if (!IsPostBack)
                {
                    LoadBranchName();
                    ActiveCall();
                }
            }
            else if (((Session["PortalTypeId"].ToString() != "") || (Convert.ToBoolean(Session["IsSuperAdmin"])) == false) && ((Convert.ToBoolean(Session["IsMultiBranch"])) == false))
            {
                cmbBranches.Enabled = false;
                cmbBranches.Visible = false;

                Cm_id = ObjSel.GETcmid(Session["Cd_Id"].ToString());  // Get cm_id
                HQ = ObjSel.Get_HQ(Cm_id);     // Get the HQ Value
                Curr_BranchFullName = ObjSel.GetBranchFullName(HQ, Session["Branch_HQ"].ToString());
                lblBranchAliasName.ForeColor = System.Drawing.Color.DodgerBlue;
                lblBranchAliasName.Text = "Branch Name" + "&nbsp;" + "-" + "&nbsp;" + Curr_BranchFullName + "&nbsp; ";

                cd_BranchAlias = Session["Branch_HQ"].ToString();
                Datapath = Session["DataPath"].ToString();
                PortalTypeId = Session["PortalTypeId"].ToString();

                DT = ObjUserBL.GetPageRightsDetailsPid(Session["UserId"].ToString(), PID);
                if (DT.Rows.Count > 0)
                {
                    Page_Acess = DT.Rows[0]["Acess_status"].ToString();
                    Read_Acess = DT.Rows[0]["Read_Access"].ToString();
                    Write_Acess = DT.Rows[0]["Write_Access"].ToString();
                    Isdowld_Acess = DT.Rows[0]["IDwld_Access"].ToString();

                    Session["Page_Acess"] = Page_Acess;
                    Session["Read_Acess"] = Read_Acess;
                    Session["Write_Acess"] = Write_Acess;
                    Session["Isdowld_Acess"] = Isdowld_Acess;
                }
                if ((Session["L_PromoCode"].ToString() == "N") || (Session["Page_Acess"].ToString() == "N"))
                {
                    Response.Redirect("DeniedPage.aspx");
                }
                else
                {
                    // lblMsgTotalSelection.Text = "Item Sale  Between" + "&nbsp;&nbsp;&nbsp;&nbsp;" + txtStartDt.Text + "&nbsp;&nbsp;&nbsp;  and  &nbsp;&nbsp;&nbsp;" + txtEndDt.Text;
                    if (!IsPostBack)
                    {
                        if (Session["Isdowld_Acess"].ToString() == "N")
                        {
                            // btnExcel.Enabled = false;
                            Response.Write(@"<script language='javascript'>alert('No Access To download.')</script>");
                        }
                        else
                        {


                            if (cmbBranches.Visible == false)
                            {
                                //  BindGridview(Session["Branch_HQ"].ToString(), txtStartDt.Text, txtEndDt.Text);
                            }

                        }


                    }

                }

            }
            else
            {

            }


        }


        public void ActiveCall()
        {
            string QueryCal = "select ActiveValue from portaldb.usermaster  where Userid=" + Session["UserId"].ToString() + " ";
            ActiveCallvalue = ObjMain.ExecuteScalar(QueryCal);
            if (ActiveCallvalue == "")
            {
                ActiveCallvalue = ObjSel.GetFirstBranch8(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), Session["CM_ID"].ToString());
            }


            ISHQ = ObjMain.ExecuteScalar("select BranchName from " + ActiveCallvalue + ".branches where Branchname='" + ActiveCallvalue + "' and branchID=1;");  //now 

            if (ISHQ != "")
            {
                ActiveCallvalue = ObjSel.GetFirstBranch8(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), Session["CM_ID"].ToString());
                UPDATEBRANCH(ActiveCallvalue);
            }

            cd_BranchAlias = ActiveCallvalue;
            Curr_BranchFullName = ObjUserBL.GetBranchCurr_BranchVal(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), cd_BranchAlias);
            Cmb_BranchName = ObjUserBL.GetBranchRealValue(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), Curr_BranchFullName);  // This will Return BranchName( Actual Database Name )
            cmbBranches.Items.FindByText(Curr_BranchFullName).Selected = true;
            Branchidval = ObjUserBL.GetBranchIDbyName(ActiveCallvalue, ActiveCallvalue);
            if (Branchidval != "")
            {
                DT = ObjUserBL.GetPageRightsDetailsPIDNew(Session["UserId"].ToString(), PID, Branchidval);
            }
            else
            {
                DT = ObjUserBL.GetPageRightsDetailsPIDNew(Session["UserId"].ToString(), PID, Session["Fistbranch"].ToString());

            }
            if (DT.Rows.Count > 0)
            {
                Page_Acess = DT.Rows[0]["Acess_status"].ToString();
                Read_Acess = DT.Rows[0]["Read_Access"].ToString();
                Write_Acess = DT.Rows[0]["Write_Access"].ToString();
                Isdowld_Acess = DT.Rows[0]["IDwld_Access"].ToString();

                Session["Page_Acess"] = Page_Acess;
                Session["Read_Acess"] = Read_Acess;
                Session["Write_Acess"] = Write_Acess;
                Session["Isdowld_Acess"] = Isdowld_Acess;
            }
            Rcd_id = ObjMain.ExecuteScalar("select cd_id from portaldb.companydetails where cd_branchid=" + cmbBranches.SelectedItem.Value + " and cd_branchalias='" + ActiveCallvalue + "';");
            RPortalid = ObjMain.ExecuteScalar("select portaltypeid  from portaldb.invoicedetails where cd_id=" + Rcd_id + ";");
            DtLicense = ObjUserBL.GetLicenseDetails(RPortalid);
            if (DtLicense.Rows.Count > 0)
            {
                L_OneTimePromocode = DtLicense.Rows[0]["ONETIMEPROMOCODE"].ToString();
                Session["L_OneTimePromocode"] = L_OneTimePromocode;
            }
            if (Session["L_OneTimePromocode"].ToString() == "N" || Session["Page_Acess"].ToString() == "N")
            {
                Response.Redirect("DeniedPage.aspx");
            }
            else
            {
                btnUpdate.Visible = false;
                btnAdd.Visible = true;

                //btnExcel.Enabled = true;
                //lblMsgTotalSelection.Text = "Total Sale Selection Between" + "&nbsp;&nbsp;&nbsp;" + txtStartDt.Text + "&nbsp;&nbsp;&nbsp;  And &nbsp;&nbsp;&nbsp;" + txtEndDt.Text;
                cd_BranchAlias = cmbBranches.SelectedItem.Text;
                // BindGridview(ActiveCallvalue, txtStartDt.Text, txtEndDt.Text);
                System.Threading.Thread.Sleep(2000);

                LoadPromoCode(Cmb_BranchName);

            }

        }
        protected void cmbBranches_SelectedIndexChanged(object sender, EventArgs e)
        {
            System.Threading.Thread.Sleep(1000);
            if (cmbBranches.SelectedIndex == 0)
            {
                Response.Redirect("OnetimePromoCode.aspx");
            }
            else
            {
                DT = ObjUserBL.GetPageRightsDetailsPIDNew(Session["UserId"].ToString(), PID, Microsoft.Security.Application.Encoder.HtmlEncode(cmbBranches.SelectedItem.Value));
                if (DT.Rows.Count > 0)
                {
                    Page_Acess = DT.Rows[0]["Acess_status"].ToString();
                    Read_Acess = DT.Rows[0]["Read_Access"].ToString();
                    Write_Acess = DT.Rows[0]["Write_Access"].ToString();
                    Isdowld_Acess = DT.Rows[0]["IDwld_Access"].ToString();

                    Session["Page_Acess"] = Page_Acess;
                    Session["Read_Acess"] = Read_Acess;
                    Session["Write_Acess"] = Write_Acess;
                    Session["Isdowld_Acess"] = Isdowld_Acess;
                }

                ISHQ = ObjMain.ExecuteScalar("select BranchName from branches where Branchname='" + ActiveCallvalue + "' and branchID=1;");  //now 

                if (ISHQ != "")
                {
                    ActiveCallvalue = ObjSel.GetFirstBranch(Session["Branch_HQ"].ToString());
                    UPDATEBRANCH(ActiveCallvalue);
                }
                else
                {
                    BranchFullName = Microsoft.Security.Application.Encoder.HtmlEncode(cmbBranches.SelectedItem.Text);    // This will Return Branch FullName 
                    Cmb_BranchName = ObjUserBL.GetBranchRealValue(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), BranchFullName);  // This will Return BranchName( Actual Database Name )
                    Rcd_id = ObjMain.ExecuteScalar("select cd_id from portaldb.companydetails where cd_branchid=" + cmbBranches.SelectedItem.Value + " and cd_branchalias='" + Cmb_BranchName + "';");
                    RPortalid = ObjMain.ExecuteScalar("select portaltypeid  from portaldb.invoicedetails where cd_id=" + Rcd_id + ";");
                    DtLicense = ObjUserBL.GetLicenseDetails(RPortalid);

                }

                UPDATEBRANCH(Cmb_BranchName);
                if (DtLicense.Rows.Count > 0)
                {
                    L_OneTimePromocode = DtLicense.Rows[0]["ONETIMEPROMOCODE"].ToString();
                    Session["L_OneTimePromocode"] = L_OneTimePromocode;
                }

                if (Session["L_OneTimePromocode"].ToString() == "N" || Session["Page_Acess"].ToString() == "N")
                {
                    Response.Redirect("DeniedPage.aspx");
                }
                else
                {
                    LoadPromoCode(Cmb_BranchName);
                }

            }




        }

        protected void btnAdd_Click(object sender, EventArgs e)
        {
            SavePromocode();
        }
        public void SavePromocode()
        {

            if (cmbBranches.Visible == false)
            {

                BranchAlias = Session["Branch_HQ"].ToString();

            }
            else
            {
                #region  Validation Between HQ Branch and Normal Branch 
                BranchFullName = cmbBranches.SelectedItem.Text;         // This will Return Branch FullName 
                if (BranchFullName == "HQ")
                {
                    BranchAlias = Session["Branch_HQ"].ToString();
                }
                else
                {
                    BranchFullName = cmbBranches.SelectedItem.Text;     // This will Return Branch FullName 
                    Cmb_BranchName = ObjUserBL.GetBranchRealValue(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), BranchFullName);  // This will Return BranchName( Actual Database Name )
                    BranchAlias = Cmb_BranchName;

                }
                #endregion
            }

            string ProQuert = "INSERT INTO {0}.OnetimePromocode ( PromoName, "
                                         + " PromoCode ,FlatPercentage,Status ,createdDate,CreatedBy ) "
                                         + " VALUES "
                                         + " (@PromoName, @PromoCode, @FlatPercentage, "
                                         + " @Status,@createdDate,@CreatedBy); ";
                       
            MySqlParameter[] parameters =
                    {
                     new MySqlParameter("@PromoName",txtPromocodeName.Text.ToString().Trim()),
                     new MySqlParameter("@PromoCode",txtPromoCode.Text.ToString().Trim()),
                     new MySqlParameter("@FlatPercentage",txtPromoValue.Text.ToString().Trim()),
                     new MySqlParameter("@Status","O"),
                     new MySqlParameter("@createdDate",Curr_Date),
                     new MySqlParameter("@CreatedBy",Session["UserId"].ToString()),

                   };

            string commmand = string.Format(ProQuert, BranchAlias);
            K = ObjMain.ExecuteQuery(commmand, parameters);
            ClearForm();
            if (K > 0)
            {
                Page page = HttpContext.Current.Handler as Page;
                ScriptManager.RegisterStartupScript(Page, Page.GetType(), "err_msg", "alert('PromoCode Added Succeessfully.');location.href='OnetimePromoCode.aspx';", true);
            }


        }
        protected void btnUpdate_Click(object sender, EventArgs e)
        {
            UpdatePromoCode(Convert.ToInt32(hidvaluePromoid.Value));
        }

        public void UpdatePromoCode(int _promoid)
        {

            btnUpdate.Visible = true;

            if (cmbBranches.Visible == false)
            {

                BranchAlias = Session["Branch_HQ"].ToString();

            }
            else
            {
                BranchFullName = Microsoft.Security.Application.Encoder.HtmlEncode(cmbBranches.SelectedItem.Text);     // This will Return Branch FullName 
                Cmb_BranchName = ObjUserBL.GetBranchRealValue(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), BranchFullName);  // This will Return BranchName( Actual Database Name )
                BranchAlias = Microsoft.Security.Application.Encoder.HtmlEncode(Cmb_BranchName);
            }
            string Update_query = " Update  {0}.OnetimePromocode set PromoName=@PromoName,"
                                + " PromoCode=@PromoCode ,FlatPercentage=@FlatPercentage, "
                                + " CreatedBy=@CreatedBy where Promoid=@Promoid ; ";
            MySqlParameter[] parameters =
                   {
                     new MySqlParameter("@Promoid",_promoid),
                     new MySqlParameter("@PromoName",txtPromocodeName.Text.ToString().Trim()),
                     new MySqlParameter("@PromoCode",txtPromoCode.Text.ToString().Trim()),
                     new MySqlParameter("@FlatPercentage",txtPromoValue.Text.ToString().Trim()),
                     new MySqlParameter("@CreatedBy",Session["UserId"].ToString()),
                   };

            string command = string.Format(Update_query, BranchAlias);

            L = ObjMain.ExecuteQuery(command, parameters);
            
        

            if (L > 0)
            {
                ScriptManager.RegisterStartupScript(Page, Page.GetType(), "err_msg", "alert('PromoCode Updated Succeessfully.');location.href='OnetimePromoCode.aspx';", true);

            }
            else
            {
                ScriptManager.RegisterStartupScript(Page, Page.GetType(), "err_msg", "alert('PromoCode Not Updated! ');", true);
            }

        }



        protected void cmbSearchByPromoCodeType_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        protected void txtPromoCode_TextChanged(object sender, EventArgs e)
        {
            if (cmbBranches.Visible == false)
            {
                BranchAlias = Session["Branch_HQ"].ToString();
            }
            else
            {
                BranchFullName = Microsoft.Security.Application.Encoder.HtmlEncode(cmbBranches.SelectedItem.Text);     // This will Return Branch FullName 
                Cmb_BranchName = ObjUserBL.GetBranchRealValue(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), BranchFullName);  // This will Return BranchName( Actual Database Name )
                BranchAlias = Microsoft.Security.Application.Encoder.HtmlEncode(Cmb_BranchName);
            }
            string  CHkPromoCodeExist = string.Empty;
            string Query = "select Promocode from {0}.OnetimePromocode where status IN ('O','E') and Promocode=@Promocode ; ";
            string command = string.Format(Query, BranchAlias);
            MySqlParameter[] parameters =
              {
                     new MySqlParameter("@Promocode",txtPromoCode.Text.ToString().Trim()),
              };
            CHkPromoCodeExist = ObjMain.NewExecuteScalar(command, parameters);

            btnUpdate.Visible = true;
            // ScriptManager.RegisterStartupScript(this, this.GetType(), "Pop", "ShowModalPromotionList();", true);
            if (CHkPromoCodeExist != "")
            {
                ScriptManager.RegisterStartupScript(Page, Page.GetType(), "err_msg", "alert('PromoCode Already Exists ! Try Other Promocode ');", true);
            }
            else
            { 
            
            }
                

        }

        public void LoadBranchName()
        {
            DtNormalUser = ObjUserBL.GetBranchOnLoginValues8(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), Session["CM_ID"].ToString());
            if (DtNormalUser.Rows.Count > 0)
            {
                cmbBranches.DataSource = DtNormalUser;
                cmbBranches.DataTextField = "branchfullname";
                cmbBranches.DataValueField = "Branchid";
                cmbBranches.DataBind();
                cmbBranches.Items.Insert(0, "Select Branch");
            }
        }
        public void LoadBranchName4SuperAdmin()
        {
            DtSuperAdmin = ObjUserBL.GetBranchOnSuperAdmin8(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), Session["CM_ID"].ToString());
            if (DtSuperAdmin.Rows.Count > 0)
            {
                cmbBranches.DataSource = DtSuperAdmin;
                cmbBranches.DataTextField = "branchfullname";
                cmbBranches.DataValueField = "Branchid";
                cmbBranches.DataBind();
                cmbBranches.Items.Insert(0, "Select Branch");
            }
        }
        public void UPDATEBRANCH(string ActiveCallvalue)
        {
            if (!string.IsNullOrEmpty(Session["UserId"] as string))
            {
                Useridvalue = Session["UserId"].ToString();
                QueryCurr_Select = "Update portaldb.usermaster set ActiveValue='" + ActiveCallvalue + "' where Userid=" + Useridvalue + "";
                S = ObjMain.ExecuteNonQuery(QueryCurr_Select);
            }
            else
            {
                Response.Redirect("Login.aspx");

            }

        }

        public void LoadPromoCode(string db)
        {
            DataTable DtResult = new DataTable();
            string Query = " select  Promoid,PromoName,Promocode,FlatPercentage, status,DATE_FORMAT(createdDate,'%Y-%m-%d') as createdDate , CreatedBy "
                         + " From {0}.OnetimePromocode where status = 'O'; ";
            string command = string.Format(Query, db);
            DtResult = ObjMain.GetData_DT(command);
            GrdPromoCode.DataSource = DtResult;
            GrdPromoCode.DataBind();
        }


        public void SearchByPromoName(string promoname)
        {
            DataTable DtResultA = new DataTable();
            if (cmbBranches.Visible == false)
            {
                BranchAlias = Session["Branch_HQ"].ToString();
            }
            else
            {
                BranchFullName = Microsoft.Security.Application.Encoder.HtmlEncode(cmbBranches.SelectedItem.Text);     // This will Return Branch FullName 
                Cmb_BranchName = ObjUserBL.GetBranchRealValue(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), BranchFullName);  // This will Return BranchName( Actual Database Name )
                BranchAlias = Microsoft.Security.Application.Encoder.HtmlEncode(Cmb_BranchName);
            }
            string Query = "select  Promoid ,PromoName,Promocode,FlatPercentage,status,createdDate,Createdby from {0}.OnetimePromocode where status = 'O' and PromoName like CONCAT('%', @PromoName, '%'); ";
            string command = string.Format(Query, BranchAlias);

            MySqlParameter[] parameters =
              {
                     new MySqlParameter("@PromoName",promoname),
              };
            DtResultA = ObjMain.NewGetData_DT(command, parameters);

            GrdPromoCode.DataSource = DtResultA;
            GrdPromoCode.DataBind();
            ScriptManager.RegisterStartupScript(this, this.GetType(), "Pop", "ShowModalPromotionList();", true);

        }

        protected void cmbPromoCodeType_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        protected void btnSearchPromocode_Click(object sender, EventArgs e)
        {
          SearchByPromoName(txtInputPromocodeName.Text);

        }

        protected void btnClear_Click(object sender, EventArgs e)
        {
            txtInputPromocodeName.Text = "";
            ScriptManager.RegisterStartupScript(this, this.GetType(), "Pop", "ShowModalPromotionList();", true);
        }

        protected void GrdPromoCode_RowCommand(object sender, GridViewCommandEventArgs e)
        {


            if (cmbBranches.Visible == false)
            {
                BranchAlias = Session["Branch_HQ"].ToString();
            }
            else
            {
                BranchFullName = Microsoft.Security.Application.Encoder.HtmlEncode(cmbBranches.SelectedItem.Text);     // This will Return Branch FullName 
                Cmb_BranchName = ObjUserBL.GetBranchRealValue(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), BranchFullName);  // This will Return BranchName( Actual Database Name )
                BranchAlias = Microsoft.Security.Application.Encoder.HtmlEncode(Cmb_BranchName);
            }
            string Name = e.CommandName;
            if (Name == "Delete")
            {
                int index = Convert.ToInt32(e.CommandArgument);
                string Update_Query = "DELETE FROM {0}.OnetimePromocode   where Promoid=@Promoid;";
                string command = string.Format(Update_Query, BranchAlias);
                MySqlParameter[] parameters =
                  {
                     new MySqlParameter("@Promoid",index),
                    
                  };
                
                K = ObjMain.ExecuteQuery(command, parameters);
                
                
                if (K > 0)
                {
                    ScriptManager.RegisterStartupScript(Page, Page.GetType(), "err_msg", "alert('PromoCode  Deleted Successfully !');location.href='OnetimePromocode.aspx';", true);
                    Response.Redirect("PromoCode.aspx");
                }
                else
                {
                    ScriptManager.RegisterStartupScript(Page, Page.GetType(), "err_msg", "alert('PromoCode Not Deleted  ! ');", true);
                }

            }



        }

        public void ClearForm()
        {
            txtPromocodeName.Text = "";
            txtPromoCode.Text = "";
            txtPromoValue.Text = "";
        }
        
        protected void OnSelectedIndexChanged(object sender, EventArgs e)
        {
            btnAdd.Visible = false;
            btnUpdate.Visible = true;

            if (cmbBranches.Visible == false)
            {
                BranchAlias = Session["Branch_HQ"].ToString();
            }
            else
            {
                BranchFullName = Microsoft.Security.Application.Encoder.HtmlEncode(cmbBranches.SelectedItem.Text);     // This will Return Branch FullName 
                Cmb_BranchName = ObjUserBL.GetBranchRealValue(Session["Branch_HQ"].ToString(), Session["UserId"].ToString(), BranchFullName);  // This will Return BranchName( Actual Database Name )
                BranchAlias = Microsoft.Security.Application.Encoder.HtmlEncode(Cmb_BranchName);
            }
            //Accessing TemplateField Column controls.
            string PromoId = (GrdPromoCode.SelectedRow.FindControl("lblPromoid") as Label).Text;
            hidvaluePromoid.Value = PromoId;
            DataTable DtResult = new DataTable();
            string Query = " select  Promoid,PromoName,Promocode,FlatPercentage, status,DATE_FORMAT(createdDate,'%Y-%m-%d') as createdDate , CreatedBy "
                         + " From {0}.OnetimePromocode where Promoid="+ PromoId + " AND status = 'O' ; ";
            string command = string.Format(Query, BranchAlias);
            MySqlParameter[] parameters =
              {
                     new MySqlParameter("@Promoid",PromoId),
              };
            DtResult = ObjMain.NewGetData_DT(command, parameters);

            if (DtResult.Rows.Count > 0)
            {
                txtPromocodeName.Text = DtResult.Rows[0]["PromoName"].ToString();
                txtPromoCode.Text = DtResult.Rows[0]["PromoCode"].ToString();
                txtPromoValue.Text = DtResult.Rows[0]["FlatPercentage"].ToString();
             }

        }
    }
}